//*****************************************************************************
//
// 		nsRPC_lookup.c  
//
//			Contains a library routine to look up the add server.
//
//*****************************************************************************


#import "nsRPC_types.h"


//*****************************************************************************
//
// 		This function finds the port that the GateKeeper DNS server has 	
//		advertised. 
//
//*****************************************************************************

port_t	nsRPC_look_up()
{
port_t			port;
kern_return_t   ret;    
	 
			/* 
			* Use "" instead of "*", so we look only on this machine.
			* (That way, we won't run into someone else who's testing 
			* this server.)
			*/
	ret = netname_look_up(name_server_port, "", GK_DNS_SERVER, &port);
	
	if (ret != KERN_SUCCESS)
	{
			/* Print the network name server's error message. */
		mach_error("Lookup of GateKeeper DNS server failed", ret);	
		return PORT_NULL;
	}
	return port;
}

