#import <appkit/View.h>

#define NSTARS (75)
#define NSTARS2 (25)
#define STARSPERIT (100)

typedef struct STAR {
	float theta;	// angle
	float distance;
	float delta;	// change in distance
	float ddelta;	// change in delta, a constant multiplier
	int changemode;
	char c;
	float changepoint[6];
	
	NXPoint r1, r2;
	NXPoint *draw;
	NXPoint *erase;
	
	} STAR;

@interface SpaceView:View
{
	STAR stars[NSTARS];
	int nstars;
	int radius;			// min radius of this view

	NXPoint b[NSTARS];
	NXPoint bOffsets[NSTARS];
	char bc [NSTARS+1];
	
	NXPoint w[NSTARS];
	NXPoint wOffsets[NSTARS];
	char wc [NSTARS+1];
	
	NXRect voidRect;	//avoid the void!
	int toggle;
	NXSize oldSize;
}

- convertToXY:(STAR *)p;
- oneStep;
- (BOOL) allowStars:(const STAR *)p;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- addStar;
- replaceStarAt:(int)index;
- setRadius;
- (const char *)windowTitle;
- setVoidRect:(const NXRect *)r;
- didLockFocus;
- (BOOL)useBufferedWindow;

- (BOOL)ignoreMouseMovement;
- inspector:sender;
- inspectorWillBeRemoved;
- inspectorInstalled;
@end

@interface StaticSpaceView:SpaceView
{
	DPSTimedEntry aniSpaceTag;
}
@end

@interface View(nonretainedFillMethod)
- fillBoundsWithBlack;
@end

			// displays animation and seconds till inactivity timeout
@interface StaticSpaceITimerView:SpaceView
{
	DPSTimedEntry aniSpaceITimerTag;
	id secTillTimeoutField;
	time_t ltime;					// time in seconds
	time_t preltime;				// previous time in seconds
	int seconds;
}
- countdown;

@end
