// -------------------------------------------------------------------------------------
// PPPMonitor
// (Indent:4, Tabs:4)
// -------------------------------------------------------------------------------------
// Copyright 1996 Persistent Technologies, Inc. - all rights reserved
// -------------------------------------------------------------------------------------
// This source code comes with no warranty of any kind, and the user assumes all 
// responsibility for its use.
// -------------------------------------------------------------------------------------
#import <appkit/Application.h>

// -------------------------------------------------------------------------------------
// misc defines
#define STRDUP(S)			((S)?strcpy((char*)malloc(strlen((char*)(S))+1),(S)):"")
#ifndef NSApp
#define NSApp NXApp
#endif

// -------------------------------------------------------------------------------------
// User defaults

#define xCMD_CONNECT		0
#define xSND_CONNECT		1
#define xFLG_SHOWSECONDS	2
#define xCMD_DISCONNECT		3
#define xSND_DISCONNECT		4
#define xCMD_TAILLOG		5
#define xCMD_PING			6
#define xCMD_PINGINTERVAL	7
#define xCMD_MINISHELF		8
#define xCMD_LOADPPPLKS		9
#define xICO_SHELFTILE		10
#define xICO_SHELFDOTS		11

#define CMD_CONNECT			[NSApp userDefaultValue:xCMD_CONNECT     ]
#define SND_CONNECT			[NSApp userDefaultValue:xSND_CONNECT     ]
#define FLG_SHOWSECONDS		[NSApp userDefaultValue:xFLG_SHOWSECONDS ]
#define CMD_DISCONNECT		[NSApp userDefaultValue:xCMD_DISCONNECT  ]
#define SND_DISCONNECT		[NSApp userDefaultValue:xSND_DISCONNECT  ]
#define CMD_TAILLOG			[NSApp userDefaultValue:xCMD_TAILLOG     ]
#define CMD_PING			[NSApp userDefaultValue:xCMD_PING        ]
#define CMD_PINGINTERVAL	[NSApp userDefaultValue:xCMD_PINGINTERVAL]
#define CMD_MINISHELF		[NSApp userDefaultValue:xCMD_MINISHELF   ]
#define CMD_LOADPPPLKS		[NSApp userDefaultValue:xCMD_LOADPPPLKS  ]
#define ICO_SHELFTILE		[NSApp userDefaultValue:xICO_SHELFTILE   ]
#define ICO_SHELFDOTS		[NSApp userDefaultValue:xICO_SHELFDOTS   ]

// -------------------------------------------------------------------------------------
@interface PPPMonitor : Application
{	

	/* preference panel */
	id			prefPanel;
	id			dftObjList;
	id			dftCmdConnect;
	id			dftSndConnect;
	id			dftAppTileTimer;
	id			dftCmdDisconnect;
	id			dftSndDisconnect;
	id			dftCmdTailLog;
	id			dftCmdPing;
	id			dftCmdPingInterval;
	id			dftMiniShelf;
	id			dftCmdLoadPPPLKS;

}
// -------------------------------------------------------------------------------------
- (const char*)readDefault:(const char*)name;
- (const char*)appName;
- (int)errorPanel:(const char*)msg;
- (const char*)userDefaultValue:(int)ndx;
- (void)showPreferences:(id)sender;

- (void)setApplicationIconImage:(NXImage*)image;

@end
